package com.javacreed.examples.axon.task;

import javax.annotation.concurrent.Immutable;

import com.google.common.base.Preconditions;

@Immutable
public class AddNoteToTaskCommand extends AbstractTaskCommand {

  public static AddNoteToTaskCommand of(final TaskId id, final TaskNote note) throws NullPointerException {
    Preconditions.checkNotNull(id);
    return new AddNoteToTaskCommand(id, note);
  }

  private final TaskNote note;

  private AddNoteToTaskCommand(final TaskId id, final TaskNote note) throws NullPointerException {
    super(id);
    this.note = note;
  }

  public TaskNote getNote() {
    return note;
  }

}
