package com.javacreed.examples.axon.task;

import javax.annotation.concurrent.Immutable;

import com.google.common.base.Preconditions;

@Immutable
public class CreateTaskCommand extends AbstractTaskCommand {

  public static CreateTaskCommand of(final TaskId id, final TaskName name) throws NullPointerException {
    Preconditions.checkNotNull(id);
    Preconditions.checkNotNull(name);
    return new CreateTaskCommand(id, name);
  }

  private final TaskName name;

  private CreateTaskCommand(final TaskId id, final TaskName name) throws NullPointerException {
    super(id);
    this.name = name;
  }

  public TaskName getName() {
    return name;
  }

}
