package com.javacreed.examples.axon.task;

import javax.annotation.concurrent.Immutable;

import com.google.common.base.Preconditions;

@Immutable
public class NoteAddedToTaskEvent {

  public static NoteAddedToTaskEvent of(final AddNoteToTaskCommand command) throws NullPointerException {
    Preconditions.checkNotNull(command);
    return new NoteAddedToTaskEvent(command);
  }

  private final TaskId taskId;
  private final TaskNote note;

  private NoteAddedToTaskEvent(final AddNoteToTaskCommand command) {
    this.taskId = command.getTaskId();
    this.note = command.getNote();
  }

  public TaskNote getNote() {
    return note;
  }

  public TaskId getTaskId() {
    return taskId;
  }
}
