package com.javacreed.examples.axon.task;

import javax.annotation.concurrent.Immutable;

import com.google.common.base.Preconditions;

@Immutable
public class TaskAlreadyCompletedEvent {

  public static TaskAlreadyCompletedEvent of(final AbstractTaskCommand command) throws NullPointerException {
    Preconditions.checkNotNull(command);
    return new TaskAlreadyCompletedEvent(command);
  }

  private final TaskId taskId;

  private TaskAlreadyCompletedEvent(final AbstractTaskCommand command) {
    this.taskId = command.getTaskId();
  }

  public TaskId getTaskId() {
    return taskId;
  }
}
