package com.javacreed.examples.axon.task;

import javax.annotation.concurrent.Immutable;

import com.google.common.base.Preconditions;

@Immutable
public class TaskCompletedEvent {

  public static TaskCompletedEvent of(final CompleteTaskCommand command) throws NullPointerException {
    Preconditions.checkNotNull(command);
    return new TaskCompletedEvent(command);
  }

  private final TaskId taskId;

  private TaskCompletedEvent(final CompleteTaskCommand command) {
    this.taskId = command.getTaskId();
  }

  public TaskId getTaskId() {
    return taskId;
  }

  public String getTaskIdValue() {
    return getTaskId().toString();
  }
}
