package com.javacreed.examples.axon.task;

import javax.annotation.concurrent.Immutable;

import com.google.common.base.Preconditions;

@Immutable
public class TaskCreatedEvent {

  public static TaskCreatedEvent of(final CreateTaskCommand command) throws NullPointerException {
    Preconditions.checkNotNull(command);
    return new TaskCreatedEvent(command);
  }

  private final TaskId id;
  private final TaskName name;

  private TaskCreatedEvent(final CreateTaskCommand command) {
    this.id = command.getTaskId();
    this.name = command.getName();
  }

  public TaskId getId() {
    return id;
  }

  public TaskName getName() {
    return name;
  }
}
