package com.javacreed.examples.axon.task;

import java.util.UUID;

import javax.annotation.concurrent.Immutable;

import com.google.common.base.Preconditions;

@Immutable
public class TaskId {

  public static TaskId of(final UUID value) throws NullPointerException {
    Preconditions.checkNotNull(value);
    return new TaskId(value);
  }

  public static TaskId random() {
    return new TaskId(UUID.randomUUID());
  }

  private final UUID value;

  private TaskId(final UUID value) {
    this.value = value;
  }

  @Override
  public boolean equals(final Object object) {
    if (this == object) {
      return true;
    }

    if (object != null && getClass() == object.getClass()) {
      return value.equals(((TaskId) object).value);
    }
    return false;
  }

  public UUID getValue() {
    return value;
  }

  @Override
  public int hashCode() {
    return value.hashCode();
  }

  @Override
  public String toString() {
    return value.toString();
  }

}
